searchData={"items":[{"type":"module","title":"Cldr.Unit.DDL","doc":"Functions to return SQL DDL commands that support the\ncreation and deletion of the `cldr_unit` database\ntype and associated aggregate functions.","ref":"Cldr.Unit.DDL.html"},{"type":"function","title":"Cldr.Unit.DDL.create_cldr_unit/1","doc":"Returns the SQL string which when executed will\ndefine the `money_with_currency` data type.","ref":"Cldr.Unit.DDL.html#create_cldr_unit/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.create_cldr_unit/1","doc":"* `db_type`: the type of the database for which the SQL\n  string should be returned.  Defaults to `:postgres` which\n  is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#create_cldr_unit/1-arguments"},{"type":"function","title":"Cldr.Unit.DDL.define_aggregate_functions/1","doc":"Returns the SQL string which when executed will\ndefine aggregate functions for the `money_with_currency`\ndata type.","ref":"Cldr.Unit.DDL.html#define_aggregate_functions/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.define_aggregate_functions/1","doc":"* `db_type`: the type of the database for which the SQL\n  string should be returned.  Defaults to `:postgres` which\n  is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#define_aggregate_functions/1-arguments"},{"type":"function","title":"Cldr.Unit.DDL.drop_aggregate_functions/1","doc":"Returns the SQL string which when executed will\ndrop the aggregate functions for the `money_with_currency`\ndata type.","ref":"Cldr.Unit.DDL.html#drop_aggregate_functions/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.drop_aggregate_functions/1","doc":"* `db_type`: the type of the database for which the SQL\n  string should be returned.  Defaults to `:postgres` which\n  is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#drop_aggregate_functions/1-arguments"},{"type":"function","title":"Cldr.Unit.DDL.drop_cldr_unit/1","doc":"Returns the SQL string which when executed will\ndrop the `money_with_currency` data type.","ref":"Cldr.Unit.DDL.html#drop_cldr_unit/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.drop_cldr_unit/1","doc":"* `db_type`: the type of the database for which the SQL\n  string should be returned.  Defaults to `:postgres` which\n  is currently the only supported database type.","ref":"Cldr.Unit.DDL.html#drop_cldr_unit/1-arguments"},{"type":"function","title":"Cldr.Unit.DDL.execute/1","doc":"Returns a string that will Ecto `execute` a single SQL\ncommand.","ref":"Cldr.Unit.DDL.html#execute/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.execute/1","doc":"* `sql` is a single SQL command","ref":"Cldr.Unit.DDL.html#execute/1-arguments"},{"type":"function","title":"Example - Cldr.Unit.DDL.execute/1","doc":"iex> Money.DDL.execute \"SELECT name FROM customers;\"\n    \"execute \"SELECT name FROM customers;\"\"","ref":"Cldr.Unit.DDL.html#execute/1-example"},{"type":"function","title":"Cldr.Unit.DDL.execute_each/1","doc":"Returns a string that will Ecto `execute` each SQL\ncommand.","ref":"Cldr.Unit.DDL.html#execute_each/1"},{"type":"function","title":"Arguments - Cldr.Unit.DDL.execute_each/1","doc":"* `sql` is a string of SQL commands that are\n  separated by three newlines (\"\\n\"),\n  that is to say two blank lines between commands\n  in the file.","ref":"Cldr.Unit.DDL.html#execute_each/1-arguments"},{"type":"function","title":"Example - Cldr.Unit.DDL.execute_each/1","doc":"iex> Money.DDL.execute \"SELECT name FROM customers;\n\n\nSELECT id FROM orders;\"\n    \"execute \"\"\"\nSELECT name FROM customers;\n\n\nSELECT id FROM orders;\n\"\"\"\"","ref":"Cldr.Unit.DDL.html#execute_each/1-example"},{"type":"module","title":"Cldr.Unit.Ecto.Composite.Type","doc":"Implements the Ecto.Type behaviour for a user-defined Postgres composite type\ncalled `:cldr_unit`.\n\nThis is the preferred option for Postgres database since the serialized unit\nvalue is stored as a decimal number,","ref":"Cldr.Unit.Ecto.Composite.Type.html"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.blank?/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#blank?/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.cast/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#cast/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.dump/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#dump/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.embed_as/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#embed_as/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.equal?/2","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#equal?/2"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.load/1","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#load/1"},{"type":"function","title":"Cldr.Unit.Ecto.Composite.Type.type/0","doc":"","ref":"Cldr.Unit.Ecto.Composite.Type.html#type/0"},{"type":"module","title":"Cldr.Unit.Ecto.Map.Type","doc":"Implements Ecto.Type behaviour for `Cldr.Unit`, where the underlying schema type\nis a map.\n\nThis is the required option for databases such as MySQL that do not support\ncomposite types.\n\nIn order to preserve precision, the value is serialized as a string since the\nJSON representation of a numeric value is either an integer or a float.\n\n`Decimal.to_string/1` is not guaranteed to produce a string that will round-trip\nconvert back to the identical number.  However given enough precision in the\n[Decimal context](https://hexdocs.pm/decimal/Decimal.Context.html#content) then\nround trip conversion should be expected.  The default precision in the context\nis 28 digits.","ref":"Cldr.Unit.Ecto.Map.Type.html"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.cast/1","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#cast/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.dump/1","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#dump/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.embed_as/1","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#embed_as/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.equal?/2","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#equal?/2"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.load/1","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#load/1"},{"type":"function","title":"Cldr.Unit.Ecto.Map.Type.type/0","doc":"","ref":"Cldr.Unit.Ecto.Map.Type.html#type/0"},{"type":"module","title":"Cldr.UnitWithUsage.Ecto.Composite.Type","doc":"Implements the Ecto.Type behaviour for a user-defined Postgres composite type\ncalled `:cldr_unit`.\n\nThis is the preferred option for Postgres database since the serialized unit\nvalue is stored as a decimal number,","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.blank?/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#blank?/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.cast/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#cast/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.dump/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#dump/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.embed_as/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#embed_as/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.equal?/2","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#equal?/2"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.load/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#load/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Composite.Type.type/0","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Composite.Type.html#type/0"},{"type":"module","title":"Cldr.UnitWithUsage.Ecto.Map.Type","doc":"Implements Ecto.Type behaviour for `Cldr.Unit`, where the underlying schema type\nis a map.\n\nThis is the required option for databases such as MySQL that do not support\ncomposite types.\n\nIn order to preserve precision, the value is serialized as a string since the\nJSON representation of a numeric value is either an integer or a float.\n\n`Decimal.to_string/1` is not guaranteed to produce a string that will round-trip\nconvert back to the identical number.  However given enough precision in the\n[Decimal context](https://hexdocs.pm/decimal/Decimal.Context.html#content) then\nround trip conversion should be expected.  The default precision in the context\nis 28 digits.","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.cast/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#cast/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.dump/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#dump/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.embed_as/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#embed_as/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.equal?/2","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#equal?/2"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.load/1","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#load/1"},{"type":"function","title":"Cldr.UnitWithUsage.Ecto.Map.Type.type/0","doc":"","ref":"Cldr.UnitWithUsage.Ecto.Map.Type.html#type/0"},{"type":"task","title":"mix units.gen.postgres.aggregate_functions","doc":"Generates a migration to add a aggregation functions\nto Postgres for the `:cldr_unit` type\n\nThis release includes only the `sum` aggregattion\nfunction.","ref":"Mix.Tasks.Units.Gen.Postgres.AggregateFunctions.html"},{"type":"task","title":"mix units.gen.postgres.cldr_units_migration","doc":"Generates a migration to add a composite type called `:cldr_unit`\nto a Postgres database.\n\nThe `:cldr_unit` type created is a composite type and\ntherefore may not be supported in other databases.","ref":"Mix.Tasks.Units.Gen.Postgres.CldrUnitsMigration.html"},{"type":"extras","title":"Introduction to Cldr Units SQL","doc":"# Introduction to Cldr Units SQL\n![Build Status](http://sweatbox.noexpectations.com.au:8080/buildStatus/icon?job=cldr_units_sql)\n[![Hex pm](http://img.shields.io/hexpm/v/ex_cldr_units_sql.svg?style=flat)](https://hex.pm/packages/ex_cldr_units_sql)\n[![License](https://img.shields.io/badge/license-Apache%202-blue.svg)](https://github.com/elixir-cldr/cldr_units_sql/blob/master/LICENSE)\n\n`ex_cldr_units_sql` implements a set of functions to store and retrieve data structured as a `Cldr.Unit.t()` type that represents a unit of measure and a value. See [ex_cldr_units](https://hex.pm/packages/ex_cldr_units) for details of using `Cldr.Unit`.  Note that `ex_cldr_units_sql` depends on `ex_cldr_units`.","ref":"readme.html"},{"type":"extras","title":"Prerequisities - Introduction to Cldr Units SQL","doc":"* `ex_cldr_units_sql` is supported on Elixir 1.11 and later only.\n\n> ##","ref":"readme.html#prerequisities"},{"type":"extras","title":"Make sure the Ecto type and the database type match! {: .warning} - Introduction to Cldr Units SQL","doc":">\n> It's important that the Ecto type `Cldr.Unit.Ecto.Composite.Type` is matched with the correct database type in the migration: `:cldr_unit` or `:cldr_unit_with_usage`.  Similarly `Cldr.Unit.Ecto.Map.Type` must be matched with the database type `:map` in the migration.","ref":"readme.html#make-sure-the-ecto-type-and-the-database-type-match-warning"},{"type":"extras","title":"Serializing to a Postgres database with Ecto - Introduction to Cldr Units SQL","doc":"`ex_cldr_units_sql` provides custom Ecto data types and two custom Postgres data types to provide serialization of `Cldr.Unit.t` types without losing precision whilst also maintaining the integrity of the `{unit, value}` relationship.  To serialise and retrieve unit types from a database the following steps should be followed:\n\n1. First generate the migration to create the custom type:\n\n```elixir\nmix units.gen.postgres.cldr_units_migration\n* creating priv/repo/migrations\n* creating priv/repo/migrations/20161007234652_add_cldr_unit_type_to_postgres.exs\n```\n\n2. Then migrate the database:\n\n```elixir\nmix ecto.migrate\n21:01:29.527 [info]  == Running 20200517121207 Cldr.Unit.SQL.Repo.Migrations.AddCldrUnitTypeToPostgres.up/0 forward\n\n21:01:29.529 [info]  execute \"CREATE TYPE public.cldr_unit AS (unit varchar, value numeric);\"\n\n21:01:29.532 [info]  execute \"CREATE TYPE public.cldr_unit_with_usage AS (unit varchar, value numeric, usage varchar);\"\n\n21:01:29.546 [info]  == Migrated 20200517121207 in 0.0s\n```\n\n3. Create your database migration with the new type (don't forget to `mix ecto.migrate` as well):\n\n```elixir\ndefmodule Cldr.Unit.Repo.Migrations.CreateProduct do\n  use Ecto.Migration\n\n  def change do\n    create table(:products) do\n      add :weight, :cldr_unit\n      add :length, :cldr_unit_with_usage\n      timestamps()\n    end\n  end\nend\n```\n\n4. Create your schema using the `Cldr.Unit.Ecto.Composite.Type` ecto type:\n\n```elixir\ndefmodule Product do\n  use Ecto.Schema\n\n  schema \"products\" do\n    field :weight, Cldr.Unit.Ecto.Composite.Type\n    field :length, Cldr.UnitWithUsage.Ecto.Composite.Type\n\n    timestamps()\n  end\nend\n```\n\n5. Insert into the database:\n\n```elixir\niex> Repo.insert %Product{weight: Cldr.Unit.new(:kilogram, Decimal.new(100))}\n[debug] QUERY OK db=4.5ms\nINSERT INTO \"products\" (\"value\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3)\n[{\"meter\", #Decimal }, {{2016, 10, 7}, {23, 12, 13, 0}}, {{2016, 10, 7}, {23, 12, 13, 0}}]\n```\n\n6. Retrieve from the database:\n\n```elixir\niex> Repo.all Product\n[debug] QUERY OK source=\"products\" db=5.3ms decode=0.1ms queue=0.1ms\nSELECT p0.\"amount\", p0.\"inserted_at\", p0.\"updated_at\" FROM \"products\" AS p0 []\n[%Product{__meta__: #Ecto.Schema.Metadata , weight: #Cldr.Unit ,\n  inserted_at: ~N[2017-02-21 00:15:40.979576],\n  updated_at: ~N[2017-02-21 00:15:40.991391]}]\n```","ref":"readme.html#serializing-to-a-postgres-database-with-ecto"},{"type":"extras","title":"Serializing to a MySQL (or other non-Postgres) database with Ecto - Introduction to Cldr Units SQL","doc":"Since MySQL does not support composite types, the `:map` type is used which in MySQL is implemented as a `JSON` column.  The currency code and amount are serialised into this column.\n```elixir\ndefmodule Cldr.Unit.Repo.Migrations.CreateProduct do\n  use Ecto.Migration\n\n  def change do\n    create table(:products) do\n      add :weight_map, :map\n      add :length_map, :map\n      timestamps()\n    end\n  end\nend\n```\n\nCreate your schema using the `Cldr.Unit.Ecto.Map.Type` ecto type:\n```elixir\ndefmodule Product do\n  use Ecto.Schema\n\n  schema \"products\" do\n    field :weight_map, Cldr.Unit.Ecto.Map.Type\n    field :length_map, Cldr.UnitWithUsage.Ecto.Map.Type\n\n    timestamps()\n  end\nend\n```\n\nInsert into the database:\n```elixir\niex> Repo.insert %Product{weight_map: Cldr.Unit.new!(:kilogram, 100)}\n[debug] QUERY OK db=25.8ms\nINSERT INTO \"products\" (\"weight_map\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3)\nRETURNING \"id\" [%{value: \"100\", unit: \"kilogram\"},\n{{2017, 2, 21}, {0, 15, 40, 979576}}, {{2017, 2, 21}, {0, 15, 40, 991391}}]\n\n{:ok,\n %Product{__meta__: #Ecto.Schema.Metadata ,\n  amount: nil, weight_map: #Cldr.Unit , id: 3,\n  inserted_at: ~N[2017-02-21 00:15:40.979576],\n  updated_at: ~N[2017-02-21 00:15:40.991391]}}\n```\n\nRetrieve from the database:\n```elixir\niex> Repo.all Product\n[debug] QUERY OK source=\"products\" db=16.1ms decode=0.1ms\nSELECT t0.\"id\", t0.\"weight_map\", t0.\"inserted_at\", t0.\"updated_at\" FROM \"products\" AS t0 []\n[%Ledger{__meta__: #Ecto.Schema.Metadata ,\n  weight_map: #Cldr.Unit , id: 3,\n  inserted_at: ~N[2017-02-21 00:15:40.979576],\n  updated_at: ~N[2017-02-21 00:15:40.991391]}]\n```\n\n#","ref":"readme.html#serializing-to-a-mysql-or-other-non-postgres-database-with-ecto"},{"type":"extras","title":"Notes: - Introduction to Cldr Units SQL","doc":"1.  In order to preserve precision of the decimal amount, the amount part of the `Cldr.Unit.t()` struct is serialised as a string. This is done because JSON serializes numeric values as either `integer` or `float`, neither of which would preserve precision of a decimal value.\n\n2.  The precision of the serialized string value is affected by the setting of `Decimal.get_context`.  The default is 28 digits which should cater for your requirements.\n\n3.  Serializing the amount as a string means that SQL query arithmetic and equality operators will not work as expected.  You may find that `CAST`ing the string value will restore some of that functionality.  For example:\n\n```sql\nCAST(JSON_EXTRACT(amount_map, '$.value') AS DECIMAL(20, 8)) AS amount;\n```","ref":"readme.html#notes"},{"type":"extras","title":"Postgres Database functions - Introduction to Cldr Units SQL","doc":"Since the datatype used to store `Cldr.Unit` in Postgres is a composite type (called `:cldr_unit`), the standard aggregation functions like `sum` and `average` are not supported and the `order_by` clause doesn't perform as expected.  `ex_cldr_units_sql` provides mechanisms to provide these functions.\n\n#","ref":"readme.html#postgres-database-functions"},{"type":"extras","title":"Aggregate functions: sum() - Introduction to Cldr Units SQL","doc":"`ex_cldr_unit_sql` provides a migration generator which, when migrated to the database with `mix ecto.migrate`, supports performing `sum()` aggregation on `:cldr_unit` types. The steps are:\n\n1. Generate the migration by executing `mix units.gen.postgres.aggregate_functions`\n\n2. Migrate the database by executing `mix ecto.migrate`\n\n3. Formulate an Ecto query to use the aggregate function `sum()`\n\n```elixir\n  # Formulate the query.  Note the required use of the type()\n  # expression which is needed to inform Ecto of the return\n  # type of the function\n  iex> q = Ecto.Query.select Product, [p], type(sum(p.weight), p.weight)\n  #Ecto.Query \n  iex> Repo.all q\n  [debug] QUERY OK source=\"products\" db=6.1ms\n  SELECT sum(p0.\"weight\")::cldr_unit_with_usage FROM \"products\" AS l0 []\n  [#Cldr.Unit ]\n```\n\nThe function `Repo.aggregate/3` can also be used. However at least [ecto version 3.2.4](https://hex/pm/packages/ecto/3.2.4) is required for this to work correctly for custom ecto types such as `:cldr_unit`.\n\n```elixir\n  iex> Repo.aggregate(Product, :sum, :weight)\n  #Cldr.Unit \n```\n\n**Note** that to preserve the integrity of `Cldr.Unit` it is not permissible to aggregate units that has different unit types.  If you attempt to aggregate unit with different unit types the query will abort and an exception will be raised:\n```elixir\n  iex> Repo.all q\n  [debug] QUERY ERROR source=\"products\" db=4.5ms\n  SELECT sum(p0.\"weight\")::cldr_unit_with_usage FROM \"products\" AS p0 []\n  ** (Postgrex.Error) ERROR 22033 (): Incompatible units. Expected all units to be :kilogram\n```\n\n#","ref":"readme.html#aggregate-functions-sum"},{"type":"extras","title":"Order_by with cldr_unit type - Introduction to Cldr Units SQL","doc":"Since `:cldr_unit` is a composite type, the default `order_by` results may surprise since the ordering is based upon the type structure, not the unit value.  Postgres defines a means to access the components of a composite type and therefore sorting can be done in a more predictable fashion.  For example:\n```elixir\n  # In this example we are decomposing the the composite column called\n  # `price` and using the sub-field `value` to perform the ordering.\n  iex> q = from p in Product, select: p.weight, order_by: fragment(\"value(weight)\")\n  #Ecto.Query \n  iex> Repo.all q\n  [debug] QUERY OK source=\"products\" db=2.0ms\n  SELECT p0.\"weight\" FROM \"products\" AS p0 ORDER BY value(weight) []\n  [#Cldr.Unit , #Cldr.Unit ,\n   #Cldr.Unit , #Cldr.Unit ]\n```\n**Note** that the results may still be unexpected.  The example above shows the correct ascending ordering by `value(weight)` however the ordering is not unit aware and therefore mixed units will return a largely meaningless order.","ref":"readme.html#order_by-with-cldr_unit-type"},{"type":"extras","title":"Installation - Introduction to Cldr Units SQL","doc":"`ex_cldr_units_sql` can be installed by adding `ex_cldr_units_sql` to your list of dependencies in `mix.exs` and then executing `mix deps.get`\n\n```elixir\ndef deps do\n  [\n    {:ex_cldr_units_sql, \"~> 1.0\"},\n    ...\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n##  Cldr Units SQL v1.0.1\n\nThis is the changelog for Cldr Units SQL v1.0.1 released on August 28th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_units_sql/tags)\n\n#","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix the project description which is returned by `mix hex.info ex_cldr_units_sql`. Thanks to @petrus-jvrensburg for the report. Closes #5.\n\n##  Cldr Units SQL v1.0.0\n\nThis is the changelog for Cldr Units SQL v1.0.0 released on April 28th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_units_sql/tags)\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Updates to [ex_cldr version 2.37.0](https://hex.pm/packages/ex_cldr/2.37.0) which includes data from [CLDR release 43](https://cldr.unicode.org/index/downloads/cldr-43)\n\n* Removes requirement and support for Ratio-based units in line with [ex_cldr_units](htttps://github.com/elixir-cldr/cldr_units).\n\n##  Cldr Units SQL v0.3.1\n\nThis is the changelog for Cldr Units SQL v0.3.1 released on July 9th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_units_sql/tags)\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Correctly compare two units in the Ecto types. Thanks to @0urobor0s for the PR. Closes #1\n\n* Fix dialyzer issues\n\n##  Cldr Units SQL v0.3.0\n\nThis is the changelog for Cldr Units SQL v0.3.0 released on June 11th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_units_sql/tags)\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix parsing to be independent of Decimal 1.x or Decimal 2.x\n\n##  Cldr Units SQL v0.2.0\n\nThis is the changelog for Cldr Units SQL v0.2.0 released on September 6th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/elixir-cldr/cldr_units_sql/tags)\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `:unit_with_usage` type to serialize units including the usage field. This requires more database storage but is a more complete serialization for round tripping unit data. The type modules are `Cldr.UnitWithUsage.Ecto.Composite.Type` and `Cldr.UnitWithUsage.Ecto.Map.Type`.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Cldr Units SQL v0.1.0 - Changelog","doc":"This is the changelog for Cldr Units SQL released on May 17th, 2020.\n\n#","ref":"changelog.html#cldr-units-sql-v0-1-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Initial release","ref":"changelog.html#enhancements"},{"type":"extras","title":"LICENSE","doc":"","ref":"license.html"},{"type":"extras","title":"License - LICENSE","doc":"Copyright 2020-2023 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this file except in\ncompliance with the License. You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software distributed under the License\nis distributed on an \"AS IS\" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\nimplied. See the License for the specific language governing permissions and limitations under the\nLicense.","ref":"license.html#license"}],"content_type":"text/markdown"}